﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MyCommand {
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        public MainWindow() {
            InitializeComponent();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tQuelle.Text = "";
        }

        private String split(String quelle, String search, bool replace) {
            int i = quelle.IndexOf(search);
            if (i<0) return "";
            String s = quelle.Substring(i);
            int i1 = s.IndexOf("\"");
            s = s.Substring(i1+1);
            i1 = s.IndexOf("\"");  // ende header
            String erg = s.Substring(0, i1);
            if (replace) {
                i1 = erg.IndexOf('_');
                while (i1 >= 0) {
                    erg = erg.Remove(i1, 1);
                    i1 = erg.IndexOf('_');
                }
            }
            return erg;
        }

        public void Message(String text, String title) {
            MessageBox.Show(text, title, MessageBoxButton.OK, MessageBoxImage.Information);
        }

        private void createListenMenues_Click(object sender, RoutedEventArgs e) {
            String[] items = tQuelle.Text.Trim().Split( new Char[] { '\r','\n'} );
            StringBuilder sbcs1 = new StringBuilder();
            StringBuilder sbcs2 = new StringBuilder();
            StringBuilder sbcomAttrib = new StringBuilder();
            StringBuilder sbcomGet = new StringBuilder();
            StringBuilder sbcomProperty = new StringBuilder();
            StringBuilder sbcomStatic1 = new StringBuilder(); // static MyCommands() {
            StringBuilder sbcomStatic2 = new StringBuilder(); // static MyCommands() {
            sbcomStatic1.AppendLine("static MyCommands() {");
            sbcomStatic2.AppendLine("static MyCommands() {");

            sbcs2.AppendLine("\r\n   private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e){\r\n" +
                "       e.CanExecute = true;\r\n"+
                "    }\r\n\r\n");

            String sHeader, sItem, sNameLower, sNameUpper;
            foreach (String item in items) {
                if (item.Trim().Equals("")) continue;
                sHeader = split(item, "Header",true);
                // Abfrage auf Name
                sItem = split(item, "Name", false);
                if (sItem.Equals("")) {
                    if (item.Contains("Command=")) {
                        //Message("Für dieses Menü existiert kein Namen\n\n" + item, "Trennen der Menüs");
                        // holes des "Namens"   Command="{x:Static local:MyCommands.OpenDBFile}
                        int i1 = item.IndexOf("MyCommands.");
                        int nChars = "MyCommands.".Length;
                        if (i1 > 0) {
                            int i2 = item.IndexOf("}");
                            if (i1 < i2) {
                                int start = i1 + nChars;
                                sItem = item.Substring(start, i2 - start);
                            }
                            else {
                                Message("Für dieses Menü existiert kein Namen bzw. MyCommands\n\n" + item, "Trennen der Menüs");
                                continue;
                            }

                        }
                        else {
                            Message("Für dieses Menü existiert kein Namen bzw. MyCommands\n\n" + item, "Trennen der Menüs");
                            continue;
                        }
                    }
                    else {
                        continue;
                    }
                }
                else {
                    if (sItem.StartsWith("main")) continue;
                    if (sItem.StartsWith("mn")) {
                        sItem = sItem.Remove(0, 2); // mnErgDL  =>  ErgDL
                    }
                }
                sNameLower = sItem.Substring(0, 1).ToLower() + sItem.Substring(1);
                sNameUpper = sItem.Substring(0, 1).ToUpper() + sItem.Substring(1);
                if (sHeader.Equals("")) sHeader = sNameLower;
                sbcomAttrib.AppendLine("   private static RoutedUICommand " + sNameLower + ";");
                sbcomProperty.AppendLine("   public static RoutedUICommand " + sNameUpper + " { set; get; }");
                sbcomStatic1.AppendLine("   " + sNameUpper + " = new RoutedUICommand(\"" + sHeader + "\", \"" + sNameUpper + "\", typeof(MyCommands));");
                sbcomStatic2.AppendLine("   " + sNameLower + " = new RoutedUICommand(\"" + sHeader + "\", \"" + sNameUpper + "\", typeof(MyCommands));");
                sbcomGet.AppendLine("   public static RoutedUICommand " + sNameUpper + " { \r\n    get { return " + sNameLower + "; }\r\n   }");

                sbcs1.AppendLine("   CommandBindings.Add(new CommandBinding(MyCommands." + sNameUpper + ", " + sNameUpper + "Executed, CheckCanExecuted));");
                sbcs2.AppendLine("   private void " + sNameUpper + "Executed(object sender, ExecutedRoutedEventArgs e) { \r\n   }");
            }
            sbcomStatic1.AppendLine("}");
            sbcomStatic2.AppendLine("}");
            tMyCommand1.Text = sbcomProperty.ToString() + "\r\n\r\n\r\n\r\n" + sbcomStatic1.ToString();
            tMyCommand2.Text = sbcomAttrib.ToString() + "\r\n\r\n\r\n\r\n" + sbcomStatic2.ToString() + "\r\n\r\n\r\n\r\n" + sbcomGet;
            tMaincs.Text = sbcs1.ToString() + "\r\n\r\n\r\n\r\n" + sbcs2.ToString();
            tabControl1.SelectedIndex = 1;
        }  // createListenMenues_Click


        private void createListenRibbonmenues_Click(object sender, RoutedEventArgs e) {
            String[] items = tQuelle.Text.Trim().Split(new Char[] { '\r', '\n' });
            StringBuilder sbcs1 = new StringBuilder();
            StringBuilder sbcs2 = new StringBuilder();
            StringBuilder sbcomAttrib = new StringBuilder();
            StringBuilder sbcomGet = new StringBuilder();
            StringBuilder sbcomProperty = new StringBuilder();
            StringBuilder sbcomStatic1 = new StringBuilder(); // static MyCommands() {
            StringBuilder sbcomStatic2 = new StringBuilder(); // static MyCommands() {
            sbcomStatic1.AppendLine("static MyCommands() {");
            sbcomStatic2.AppendLine("static MyCommands() {");

            sbcs2.AppendLine("\r\n   private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e){\r\n" +
                "       e.CanExecute = true;\r\n" +
                "    }\r\n\r\n");

            String sHeader, sItem, sNameLower, sNameUpper;
            foreach (String item in items) {
                if (item.Trim().Equals("")) continue;
                sHeader = split(item, "Header", true);
                // Abfrage auf Name
                int i = item.IndexOf("Command=\"{x:Static local:MyCommands.");
                sItem = "";
                if (i>0) {
                    //Message("Für dieses Menü existiert kein Namen\n\n" + item, "Trennen der Menüs");
                    // holes des "Namens"   Command="{x:Static local:MyCommands.OpenDBFile}
                    int i1 = item.IndexOf("MyCommands.");
                    int nChars = "MyCommands.".Length;
                    if (i1 > 0) {
                        int i2 = item.IndexOf("}");
                        if (i1 < i2) {
                            int start = i1 + nChars;
                            sItem = item.Substring(start, i2 - start);
                        }
                        else {
                            Message("Für dieses Menü existiert kein Namen bzw. MyCommands\n\n" + item, "Trennen der Menüs");
                            continue;
                        }

                    }
                    else {
                        Message("Für dieses Menü existiert kein Namen bzw. MyCommands\n\n" + item, "Trennen der Menüs");
                        continue;
                    }
                }
                else {
                    continue;
                }
                if (sItem.Length == 0) continue;
                sNameLower = sItem.Substring(0, 1).ToLower() + sItem.Substring(1);
                sNameUpper = sItem.Substring(0, 1).ToUpper() + sItem.Substring(1);
                if (sHeader.Equals("")) sHeader = sNameLower;
                sbcomAttrib.AppendLine("   private static RoutedUICommand " + sNameLower + ";");
                sbcomProperty.AppendLine("   public static RoutedUICommand " + sNameUpper + " { set; get; }");
                sbcomStatic1.AppendLine("   " + sNameUpper + " = new RoutedUICommand(\"" + sHeader + "\", \"" + sNameUpper + "\", typeof(MyCommands));");
                sbcomStatic2.AppendLine("   " + sNameLower + " = new RoutedUICommand(\"" + sHeader + "\", \"" + sNameUpper + "\", typeof(MyCommands));");
                sbcomGet.AppendLine("   public static RoutedUICommand " + sNameUpper + " { \r\n    get { return " + sNameLower + "; }\r\n   }");

                sbcs1.AppendLine("   CommandBindings.Add(new CommandBinding(MyCommands." + sNameUpper + ", " + sNameUpper + "Executed, CheckCanExecuted));");
                sbcs2.AppendLine("   private void " + sNameUpper + "Executed(object sender, ExecutedRoutedEventArgs e) { \r\n   }");
            }
            sbcomStatic1.AppendLine("}");
            sbcomStatic2.AppendLine("}");
            tMyCommand1.Text = sbcomProperty.ToString() + "\r\n\r\n\r\n\r\n" + sbcomStatic1.ToString();
            tMyCommand2.Text = sbcomAttrib.ToString() + "\r\n\r\n\r\n\r\n" + sbcomStatic2.ToString() + "\r\n\r\n\r\n\r\n" + sbcomGet;
            tMaincs.Text = sbcs1.ToString() + "\r\n\r\n\r\n\r\n" + sbcs2.ToString();
            tabControl1.SelectedIndex = 1;
        }

    }
}
